Files
distrobox/distrobox-rm
T

235 lines
6.1 KiB
Bash
Executable File

#!/bin/sh
# SPDX-License-Identifier: GPL-3.0-only
#
# This file is part of the distrobox project:
# https://github.com/89luca89/distrobox
#
# Copyright (C) 2021 distrobox contributors
#
# distrobox is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 3
# as published by the Free Software Foundation.
#
# distrobox is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with distrobox; if not, see <http://www.gnu.org/licenses/>.
# POSIX
# Optional env variables:
# DBX_CONTAINER_MANAGER
# DBX_CONTAINER_NAME
# DBX_NON_INTERACTIVE
# Dont' run this command as sudo.
if [ "$(id -u)" -eq 0 ]; then
printf >&2 "Running %s as sudo is not supported.\n" "${0}"
printf >&2 "Please check the documentation on:\n"
printf >&2 "\tman distrobox-compatibility\t"
printf >&2 "or consult the documentation page on:\n"
printf >&2 "\thttps://github.com/89luca89/distrobox/blob/main/docs/compatibility.md\n"
exit 1
fi
# Defaults
container_manager="autodetect"
container_name="fedora-toolbox-35"
force=0
non_interactive=0
verbose=0
version="1.2.15"
# Source configuration files, this is done in an hierarchy so local files have
# priority over system defaults
# leave priority to environment variables.
config_files="
/usr/share/distrobox/distrobox.conf
/etc/distrobox/distrobox.conf
${HOME}/.config/distrobox/distrobox.conf
${HOME}/.distroboxrc
"
for config_file in ${config_files}; do
# shellcheck disable=SC1090
[ -e "${config_file}" ] && . "${config_file}"
done
[ -n "${DBX_CONTAINER_MANAGER}" ] && container_manager="${DBX_CONTAINER_MANAGER}"
[ -n "${DBX_CONTAINER_NAME}" ] && container_name="${DBX_CONTAINER_NAME}"
[ -n "${DBX_NON_INTERACTIVE}" ] && non_interactive="${DBX_NON_INTERACTIVE}"
# Print usage to stdout.
# Arguments:
# None
# Outputs:
# print usage with examples.
show_help() {
cat <<EOF
distrobox version: ${version}
Usage:
distrobox-rm --name container-name [--force]
distrobox-rm container-name [-f]
Options:
--name/-n: name for the distrobox
--force/-f: force deletion
--help/-h: show this message
--verbose/-v: show more verbosity
--version/-V: show version
EOF
}
# Parse arguments
while :; do
case $1 in
-h | --help)
# Call a "show_help" function to display a synopsis, then exit.
show_help
exit 0
;;
-v | --verbose)
verbose=1
shift
;;
-V | --version)
printf "distrobox: %s\n" "${version}"
exit 0
;;
-f | --force)
force=1
shift
;;
-n | --name)
if [ -n "$2" ]; then
container_name="$2"
shift
shift
fi
;;
-Y | --yes)
non_interactive=1
shift
;;
--) # End of all options.
shift
break
;;
*) # Default case: If no more options then break out of the loop.
# If we have a flagless option and container_name is not specified
# then let's accept argument as container_name
if [ -n "$1" ]; then
container_name="$1"
shift
else
break
fi
;;
esac
done
set -o errexit
set -o nounset
# set verbosity
if [ "${verbose}" -ne 0 ]; then
set -o xtrace
fi
# We depend on a container manager let's be sure we have it
# First we use podman, else docker
case "${container_manager}" in
autodetect)
if command -v podman >/dev/null; then
container_manager="podman"
elif command -v docker >/dev/null; then
container_manager="docker"
else
container_manager="not_found"
fi
;;
podman)
container_manager="podman"
;;
docker)
container_manager="docker"
;;
*)
printf >&2 "Invalid input %s.\n" "${container_manager}"
printf >&2 "The available choices are: 'autodetect', 'podman', 'docker'\n"
container_manager="not_found"
;;
esac
# Be sure we have a container manager to work with.
if ! command -v "${container_manager}" >/dev/null; then
# Error: we need at least one between docker or podman.
printf >&2 "Missing dependency: we need a container manager.\n"
printf >&2 "Please install one of podman or docker.\n"
printf >&2 "You can follow the documentation on:\n"
printf >&2 "\tman distrobox-compatibility\n"
printf >&2 "or:\n"
printf >&2 "\thttps://github.com/89luca89/distrobox/blob/main/docs/compatibility.md\n"
exit 127
fi
# add verbose if -v is specified
if [ "${verbose}" -ne 0 ]; then
container_manager="${container_manager} --log-level debug"
fi
# Inspect the container we're working with.
container_status="$(${container_manager} inspect --type container \
"${container_name}" --format '{{.State.Status}}')"
container_exists="$?"
# Does the container exist? check if inspect reported errors
if [ "${container_exists}" -gt 0 ]; then
# If not, prompt to create it first
printf >&2 "Cannot find container %s, does it exist?\n" "${container_name}"
exit 1
fi
# If the container is not already running, we need to start if first
if [ "${container_status}" = "running" ]; then
if [ "${force}" -ne 0 ]; then
printf >&2 "Stopping container %s\n" "${container_name}"
if ! ${container_manager} stop "${container_name}"; then
printf >&2 "Could not stop container %s\n" "${container_name}"
printf >&2 "Please stop container %s before deletion\n" "${container_name}"
printf >&2 "Run:\n\t%s stop %s" "${container_manager}" "${container_name}"
exit 1
fi
else
printf >&2 "Please stop container %s before deletion\n" "${container_name}"
printf >&2 "Run:\n\t%s stop %s\n" "${container_manager}" "${container_name}"
printf >&2 'or use the "--force" flag'
exit 1
fi
fi
if [ "${non_interactive}" -eq 0 ] && [ "${force}" -eq 0 ]; then
# Prompt to download it.
printf "Do you really want to delete %s? [Y/n]: " "${container_name}"
read -r response
response="${response:-"Y"}"
else
response="yes"
fi
# Accept only y,Y,Yes,yes,n,N,No,no.
case "${response}" in
y | Y | Yes | yes | YES)
# Remove the container
${container_manager} rm "${container_name}"
;;
n | N | No | no | NO)
printf "Aborted.\n"
exit 0
;;
*) # Default case: If no more options then break out of the loop.
printf >&2 "Invalid input.\n"
printf >&2 "The available choices are: y,Y,Yes,yes,YES or n,N,No,no,NO.\nExiting.\n"
exit 1
;;
esac